﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Controls;


namespace FriskaDama
{
    public abstract class Figurka
    {
        /// <summary>
        /// Vlastnost vrací obrázek figurky
        /// </summary>
        public Image Obrazek
        {
            get
            {
                Image obrazek = new Image();
                obrazek.Source = new BitmapImage(new Uri(CestaKObrazku, UriKind.Relative));
                obrazek.SetValue(RenderOptions.BitmapScalingModeProperty, BitmapScalingMode.Fant);
                return obrazek;
            }
        }

        /// <summary>
        /// Hodnota figurky (pro AI)
        /// </summary>
        public int Hodnota { get; protected set; }

        /// <summary>
        /// Cesta k obrázku
        /// </summary>
        public string CestaKObrazku { get; protected set; }

        /// <summary>
        /// Určuje, jestli je figurka modrá / červená
        /// </summary>
        public bool Modra { get; protected set; }

        /// <summary>
        /// Souřadnice figurky
        /// </summary>
        public Souradnice Souradnice { get; set; }

        /// <summary>
        /// Všechny možné tahy figurky
        /// </summary>
        /// <returns></returns>
        public abstract Tah[] MozneTahy();

        /// <summary>
        /// Všechny možné tahy figurky s možností vyhození protihráče
        /// </summary>
        /// <returns></returns>
        public abstract Tah[] MozneUtoky();

        protected Figurka(bool modra, Souradnice souradnice)
        {
            Modra = modra;
            Souradnice = souradnice;
        }
    }
}
