﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FriskaDama
{
    class Dama : Figurka
    {
        public Dama(bool bila, Souradnice souradnice) : base(bila, souradnice)
        {
            Hodnota = 10;
            // Nastavení obrázku modré / červené figurky
            if (Modra)
            {
                CestaKObrazku = "Obrazky/BlueKing.bmp";
            }
            else
            {
                CestaKObrazku = "Obrazky/RedKing.bmp";
            }
        }

        public override Tah[] MozneTahy()
        {
            // Kolekce políček možných tahů
            List<Tah> mozneTahy = new List<Tah>();
            int pricist = 0;

            // Označí levou stranu řádku do možného přesunu
            for (int i = Souradnice.Sloupec - 2; i >= 0; i -= 2)
            {
                // Zkontroluje jestli je budoucí políčko prázdné
                if (i >= 0 && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek, i]));
                }
                else if (i - 2 >= 0 && Modra && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek, i - 2].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek, i - 2]));
                }
                else if (i - 2 >= 0 && !Modra && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka.Modra == true && Hra.PolickaHraciDesky[Souradnice.Radek, i - 2].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek, i - 2]));
                }
                else
                {
                    break;
                }
            }

            // Označí pravou stranu řádku do možného přesunu
            for (int i = Souradnice.Sloupec + 2; i <= 9; i += 2)
            {
                // Zkontroluje jestli je budoucí políčko prázdné
                if (i <= 9 && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek, i]));
                }
                else if ( i + 2 <= 9 && Modra && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek, i + 2].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek, i + 2]));
                }
                else if (i + 2 <= 9 && !Modra && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka.Modra == true && Hra.PolickaHraciDesky[Souradnice.Radek, i + 2].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek, i + 2]));
                }
                else
                {
                    break;
                }
            }

            // Označí horní stranu sloupce do možného přesunu
            for (int i = Souradnice.Radek - 2; i >= 0; i -= 2)
            {
                // Zkontroluje jestli je budoucí políčko prázdné
                if (i >= 0 && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[i, Souradnice.Sloupec]));
                }
                else if (i - 2 >= 0 && Modra && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka != null && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka.Modra == false && Hra.PolickaHraciDesky[i - 2, Souradnice.Sloupec].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[i - 2, Souradnice.Sloupec]));
                }
                else if (i - 2 >= 0 && !Modra && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka != null && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka.Modra == true && Hra.PolickaHraciDesky[i - 2, Souradnice.Sloupec].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[i - 2, Souradnice.Sloupec]));
                }
                else
                {
                    break;
                }
            }

            // Označí spodní stranu sloupce do možného přesunu
            for (int i = Souradnice.Radek + 2; i <= 9; i += 2)
            {
                // Zkontroluje jestli je budoucí políčko prázdné
                if (i <= 9 && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[i, Souradnice.Sloupec]));
                }
                else if (i + 2 <= 9 && Modra && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka != null && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka.Modra == false && Hra.PolickaHraciDesky[i + 2, Souradnice.Sloupec].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[i + 2, Souradnice.Sloupec]));
                }
                else if (i + 2 <= 9 && !Modra && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka != null && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka.Modra == true && Hra.PolickaHraciDesky[i + 2, Souradnice.Sloupec].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[i + 2, Souradnice.Sloupec]));
                }
                else
                {
                    break;
                }
            }

            // Označí od pravé spodní strany do levé horní strany
            for (int i = Souradnice.Sloupec - 1; i >= 0; i--)
            {
                pricist++;
                if (Souradnice.Radek - pricist >= 0 && i >= 0 && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i]));
                }
                else if (Souradnice.Radek - pricist - 1 >= 0 && i - 1 >= 0 && Souradnice.Sloupec >= 2 && Modra && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek - pricist - 1, i - 1].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - pricist - 1, i - 1]));
                }
                else if (Souradnice.Radek - pricist - 1 >= 0 && i - 1 >= 0 && !Modra && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka.Modra == true && Hra.PolickaHraciDesky[Souradnice.Radek - pricist - 1, i - 1].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - pricist - 1, i - 1]));
                }
                else
                {
                    break;
                }
            }

            pricist = 0;

            // Označí od levé spodní strany do pravé horní strany
            for (int i = Souradnice.Sloupec + 1; i <= 9; i++)
            {

                pricist++;
                if (Souradnice.Radek - pricist >= 0 && i <= 9 && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i]));
                }
                else if (Souradnice.Radek - pricist - 1 >= 0 && i + 1 <= 9 && Modra && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek - pricist - 1, i + 1].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - pricist - 1, i + 1]));
                }
                else if (Souradnice.Radek - pricist - 1 >= 0 && i + 1 <= 9 && !Modra && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka.Modra == true && Hra.PolickaHraciDesky[Souradnice.Radek - pricist - 1, i + 1].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - pricist - 1, i + 1]));
                }
                else
                {
                    break;
                }
            }
            pricist = 0;

            // Označí od pravé horní strany do levé dolní strany
            for (int i = Souradnice.Sloupec - 1; i >= 0; i--)
            {
                pricist++;
                if (Souradnice.Radek + pricist <= 9 && i >= 0 && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i]));
                }
                else if (Souradnice.Radek + pricist + 1 <= 9 && i - 1 >= 0 && Modra && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek + pricist + 1, i - 1].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + pricist + 1, i - 1]));
                }
                else if (Souradnice.Radek + pricist + 1 <= 9 && i - 1 >= 0 && !Modra && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka.Modra == true && Hra.PolickaHraciDesky[Souradnice.Radek + pricist + 1, i - 1].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + pricist + 1, i - 1]));
                }
                else
                {
                    break;
                }
            }
            pricist = 0;

            // Označí od levé horní strany do pravé dolní strany
            for (int i = Souradnice.Sloupec + 1; i <= 9; i++)
            {
                pricist++;
                if (Souradnice.Radek + pricist <= 9 && i <= 9 && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i]));
                }
                else if (Souradnice.Radek + pricist + 1 <= 9 && i + 1 <= 9 && Modra && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek + pricist + 1, i + 1].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + pricist + 1, i + 1]));
                }
                else if (Souradnice.Radek + pricist + 1 <= 9 && i + 1 <= 9 && !Modra && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka.Modra == true && Hra.PolickaHraciDesky[Souradnice.Radek + pricist + 1, i + 1].Figurka == null)
                {
                    mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + pricist + 1, i + 1]));
                }
                else
                {
                    break;
                }
            }
            pricist = 0;

            return mozneTahy.ToArray();
        }


        public override Tah[] MozneUtoky()
        {
            // Kolekce políček možných tahů
            List<Tah> mozneVyhozeneFigurky = new List<Tah>();
            int pricist = 0;

            // Označí levou stranu řádku do možného přesunu
            for (int i = Souradnice.Sloupec - 2; i >= 0; i -= 2)
            {
                if (i - 2 >= 0 && Modra && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek, i - 2].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek, i]));
                 
                }
                else if (i - 2 >= 0 && !Modra && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka.Modra == true && Hra.PolickaHraciDesky[Souradnice.Radek, i - 2].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek, i]));
                }
                else if (Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka == null)
                {
                    continue;
                }
                else
                {
                    break;
                }
            }

            // Označí pravou stranu řádku do možného přesunu
            for (int i = Souradnice.Sloupec + 2; i <= 9; i += 2)
            {

                if (i + 2 <= 9 && Modra && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek, i + 2].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek, i]));
                }
                else if (i + 2 <= 9 && !Modra && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka.Modra == true && Hra.PolickaHraciDesky[Souradnice.Radek, i + 2].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek, i]));
                }
                else if (Hra.PolickaHraciDesky[Souradnice.Radek, i].Figurka == null)
                {
                    continue;
                }
                else
                {
                    break;
                }
            }

            // Označí horní stranu sloupce do možného přesunu
            for (int i = Souradnice.Radek - 2; i >= 0; i -= 2)
            {
                if (i - 2 >= 0 && Modra && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka != null && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka.Modra == false && Hra.PolickaHraciDesky[i - 2, Souradnice.Sloupec].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[i, Souradnice.Sloupec]));
                }
                else if (i - 2 >= 0 && !Modra && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka != null && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka.Modra == true && Hra.PolickaHraciDesky[i - 2, Souradnice.Sloupec].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[i, Souradnice.Sloupec]));
                }
                else if (Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka == null)
                {
                    continue;
                }
                else
                {
                    break;
                }
            }

            // Označí spodní stranu sloupce do možného přesunu
            for (int i = Souradnice.Radek + 2; i <= 9; i += 2)
            {
                if (i + 2 <= 9 && Modra && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka != null && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka.Modra == false && Hra.PolickaHraciDesky[i + 2, Souradnice.Sloupec].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[i, Souradnice.Sloupec]));
                }
                else if (i + 2 <= 9 && !Modra && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka != null && Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka.Modra == true && Hra.PolickaHraciDesky[i + 2, Souradnice.Sloupec].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[i, Souradnice.Sloupec]));
                }
                else if (Hra.PolickaHraciDesky[i, Souradnice.Sloupec].Figurka == null)
                {
                    continue;
                }
                else
                {
                    break;
                }
            }
            // Označí od pravé spodní strany do levé horní strany
            for (int i = Souradnice.Sloupec - 1; i >= 0; i--)
            {
                pricist++;
                if (Souradnice.Radek - pricist >= 1 && i >= 1 && Modra && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek - pricist - 1, i - 1].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i]));
                }
                else if (Souradnice.Radek - pricist >= 1 && i >= 1 && !Modra && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka.Modra == true && Hra.PolickaHraciDesky[Souradnice.Radek - pricist - 1, i - 1].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i]));
                }
                else if (Souradnice.Radek - pricist >= 0 && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka == null)
                {
                    continue;
                }
                else
                {
                    break;
                }
            }
            pricist = 0;

            // Označí od levé spodní strany do pravé horní strany
            for (int i = Souradnice.Sloupec + 1; i <= 9; i++)
            {

                pricist++;
                if (Souradnice.Radek - pricist >= 1 && i <= 8 && Modra && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek - pricist - 1, i + 1].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i]));
                }
                else if (Souradnice.Radek - pricist >= 1 && i <= 8 && !Modra && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka.Modra == true && Hra.PolickaHraciDesky[Souradnice.Radek - pricist - 1, i + 1].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i]));
                }
                else if (Souradnice.Radek - pricist >= 0 && Hra.PolickaHraciDesky[Souradnice.Radek - pricist, i].Figurka == null)
                {
                    continue;
                }
                else
                {
                    break;
                }
            }
            pricist = 0;

            // Označí od pravé horní strany do levé dolní strany
            for (int i = Souradnice.Sloupec - 1; i >= 0; i--)
            {
                pricist++;
                if (Souradnice.Radek + pricist <= 8 && i >= 1 && Modra && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek + pricist + 1, i - 1].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i]));
                }
                else if (Souradnice.Radek + pricist <= 8 && i >= 1 && !Modra && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka.Modra == true && Hra.PolickaHraciDesky[Souradnice.Radek + pricist + 1, i - 1].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i]));
                }
                else if (Souradnice.Radek + pricist <= 9 && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka == null)
                {
                    continue;
                }
                else
                {
                    break;
                }
            }
            pricist = 0;

            // Označí od levé horní strany do pravé dolní strany
            for (int i = Souradnice.Sloupec + 1; i <= 9; i++)
            {
                pricist++;
                if (Souradnice.Radek + pricist <= 8 && i <= 8 && Modra && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek + pricist + 1, i + 1].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i]));
                }
                else if (Souradnice.Radek + pricist <= 8 && i <= 8 && !Modra && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka.Modra == true && Hra.PolickaHraciDesky[Souradnice.Radek + pricist + 1, i + 1].Figurka == null)
                {
                    mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i]));
                }
                else if (Souradnice.Radek + pricist <= 9 && Hra.PolickaHraciDesky[Souradnice.Radek + pricist, i].Figurka == null)
                {
                    continue;
                }
                else
                {
                    break;
                }
            }
            pricist = 0;

            return mozneVyhozeneFigurky.ToArray();
        }
    }
}
