﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FriskaDama
{
    class Kamen : Figurka
    {
        public Kamen(bool modra, Souradnice souradnice) : base(modra, souradnice)
        {
            Hodnota = 5;
            // Nastavení obrázku modré / červené figurky
            if (Modra)
            {
                CestaKObrazku = "Obrazky/Blue.bmp";
            }
            else
            {
                CestaKObrazku = "Obrazky/Red.bmp";
            }
        }

        public override Tah[] MozneTahy()
        {
            // Kolekce políček možných tahů
            List<Tah> mozneTahy = new List<Tah>();

            // Ošetří, jestli se figurka nenachází na posledním řádku
            if ((!Modra && Souradnice.Radek < 9) || (Modra && Souradnice.Radek > 0))
            {
                // Modrá figurka
                if (Modra)
                {
                    // Pokud se figurka nachází v prvním sloupci
                    if (Souradnice.Sloupec == 0)
                    {
                        if (Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1]));
                        }
                        if (Souradnice.Radek > 1 && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek - 2, Souradnice.Sloupec + 2].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - 2, Souradnice.Sloupec + 2]));
                        }
                    }

                    // Pokud se figurka nachází v posledním sloupci
                    else if (Souradnice.Sloupec == 9)
                    {
                        if (Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1]));
                        }
                        if (Souradnice.Radek > 1 && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek - 2, Souradnice.Sloupec - 2].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - 2, Souradnice.Sloupec - 2]));
                        }
                    }
                    // Pokud se figurka nachází uprostřed
                    else
                    {
                        if (Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1]));
                        }
                        if (Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1]));
                        }
                        if (Souradnice.Radek > 1 && Souradnice.Sloupec > 1 && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek - 2, Souradnice.Sloupec - 2].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - 2, Souradnice.Sloupec - 2]));
                        }
                        if (Souradnice.Radek > 1 && Souradnice.Sloupec < 8 && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek - 2, Souradnice.Sloupec + 2].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - 2, Souradnice.Sloupec + 2]));
                        }
                    }
                }

                // Červená figurka
                else
                {
                    if (Souradnice.Sloupec == 0)
                    {
                        if (Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1]));
                        }
                        if (Souradnice.Radek < 8 && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1].Figurka.Modra && Hra.PolickaHraciDesky[Souradnice.Radek + 2, Souradnice.Sloupec + 2].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + 2, Souradnice.Sloupec + 2]));
                        }
                    }

                    else if (Souradnice.Sloupec == 9)
                    {
                        if (Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1]));
                        }
                        if (Souradnice.Radek < 8 && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1].Figurka.Modra && Hra.PolickaHraciDesky[Souradnice.Radek + 2, Souradnice.Sloupec - 2].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + 2, Souradnice.Sloupec - 2]));
                        }
                    }

                    else
                    {
                        if (Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1]));
                        }
                        if (Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1]));
                        }
                        if (Souradnice.Radek < 8 && Souradnice.Sloupec > 1 && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1].Figurka.Modra && Hra.PolickaHraciDesky[Souradnice.Radek + 2, Souradnice.Sloupec - 2].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + 2, Souradnice.Sloupec - 2]));
                        }
                        if (Souradnice.Radek < 8 && Souradnice.Sloupec < 8 && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1].Figurka.Modra && Hra.PolickaHraciDesky[Souradnice.Radek + 2, Souradnice.Sloupec + 2].Figurka == null)
                        {
                            mozneTahy.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + 2, Souradnice.Sloupec + 2]));
                        }
                    }
                }
            }

            return mozneTahy.ToArray();
        }


        public override Tah[] MozneUtoky()
        {
            // Kolekce políček možných tahů
            List<Tah> mozneVyhozeneFigurky = new List<Tah>();

            // Ošetří, jestli se figurka nenachází na posledním řádku
            if (( !Modra && Souradnice.Radek < 9) || (Modra && Souradnice.Radek > 0))
            {
                // Modrá figurka
                if (Modra)
                {
                    // Pokud se figurka nachází v prvním sloupci
                    if (Souradnice.Sloupec == 0)
                    {
                        if (Souradnice.Radek > 1 && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek - 2, Souradnice.Sloupec + 2].Figurka == null )
                        {
                            mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1]));
                        }
                    }

                    // Pokud se figurka nachází v posledním sloupci
                    else if (Souradnice.Sloupec == 9)
                    {
                        if (Souradnice.Radek > 1 && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek - 2, Souradnice.Sloupec - 2].Figurka == null )
                        {
                            mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1]));
                        }
                    }
                    // Pokud se figurka nachází uprostřed
                    else
                    {
                        if (Souradnice.Radek > 1 && Souradnice.Sloupec > 1 && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek - 2, Souradnice.Sloupec - 2].Figurka == null)
                        {
                            mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec - 1]));
                        }
                        if (Souradnice.Radek > 1 && Souradnice.Sloupec < 8 && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1].Figurka.Modra == false && Hra.PolickaHraciDesky[Souradnice.Radek - 2, Souradnice.Sloupec + 2].Figurka == null)
                        {
                            mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek - 1, Souradnice.Sloupec + 1]));
                        }
                    }
                }

                // Červená figurka
                else
                {
                    if (Souradnice.Sloupec == 0)
                    {
                        if (Souradnice.Radek < 8 && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1].Figurka.Modra && Hra.PolickaHraciDesky[Souradnice.Radek + 2, Souradnice.Sloupec + 2].Figurka == null )
                        {
                            mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1]));
                        }
                    }

                    else if (Souradnice.Sloupec == 9)
                    {
                        if (Souradnice.Radek < 8 && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1].Figurka.Modra && Hra.PolickaHraciDesky[Souradnice.Radek + 2, Souradnice.Sloupec - 2].Figurka == null )
                        {
                            mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1]));
                        }
                    }

                    else
                    {
                        if (Souradnice.Radek < 8 && Souradnice.Sloupec > 1 && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1].Figurka.Modra && Hra.PolickaHraciDesky[Souradnice.Radek + 2, Souradnice.Sloupec - 2].Figurka == null )
                        {
                            mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec - 1]));
                        }
                        if (Souradnice.Radek < 8 && Souradnice.Sloupec < 8 && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1].Figurka != null && Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1].Figurka.Modra && Hra.PolickaHraciDesky[Souradnice.Radek + 2, Souradnice.Sloupec + 2].Figurka == null )
                        {
                            mozneVyhozeneFigurky.Add(new Tah(Hra.PolickaHraciDesky[Souradnice.Radek, Souradnice.Sloupec], Hra.PolickaHraciDesky[Souradnice.Radek + 1, Souradnice.Sloupec + 1]));
                        }
                    }
                }
            }

            return mozneVyhozeneFigurky.ToArray();
        }
    }
}
