﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FriskaDama
{
    /// <summary>
    /// Interakční logika pro MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public bool HracModreFigurky { get; private set; }
        public bool HracCerveneFigurky { get; private set; }
        List<Policko> oznacenePolicko;
        AI cerveneAi;
        bool novaHra;
        bool oznaceno;
        int hloubka = 2;

        public MainWindow()
        {
            InitializeComponent();

            this.HracCerveneFigurky = true;
            this.HracModreFigurky = true;
            oznaceno = false;
        }

        private void novaMenuItem_Click(object sender, RoutedEventArgs e)
        {
            NovaHraWindow novaHraWindow = new NovaHraWindow(HracCerveneFigurky, HracModreFigurky);
            novaHraWindow.ShowDialog();
            this.HracCerveneFigurky = novaHraWindow.HracCerveneFigurky;
            this.HracModreFigurky = novaHraWindow.HracModreFigurky;

            if(novaHraWindow.Nastaveno == true)
            {
                novaHra = true;
            }

            if(novaHra)
            {
                NovaHra();
            }
        }

        private void konecMenuItem_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        public void NovaHra()
        {
            novaHra = false;
            Hra.NovaHra(this);
        }

        private void grid_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (((HracModreFigurky && Hra.ModraNaTahu) || (HracCerveneFigurky && !Hra.ModraNaTahu)) && Hra.KonecHry == false)
            {
                if (e.Source is Button)
                {
                    Button zmacknuteTlacitko = (Button)e.Source;
                    // Kliknuto na neoznačené políčko
                    if (!oznaceno)
                    {
                        // Kliknutí na políčko s figurkou
                        if (Hra.PolickaHraciDesky[((Souradnice)zmacknuteTlacitko.Tag).Radek, ((Souradnice)zmacknuteTlacitko.Tag).Sloupec].Figurka != null)
                        {
                            // Kliknutí na figurku, která je na tahu
                            if (Hra.ModraNaTahu == Hra.PolickaHraciDesky[((Souradnice)zmacknuteTlacitko.Tag).Radek, ((Souradnice)zmacknuteTlacitko.Tag).Sloupec].Figurka.Modra)
                            {
                                oznacenePolicko = new List<Policko>();
                                // Přidá zmáčknuté políčko 
                                oznacenePolicko.Add(Hra.PolickaHraciDesky[((Souradnice)zmacknuteTlacitko.Tag).Radek, ((Souradnice)zmacknuteTlacitko.Tag).Sloupec]);
                                // Zkopíruje pole možného přesunu figurky na zmáčknutém tlačítku do označených políček
                                oznacenePolicko.InsertRange(1, Hra.PolickaHraciDesky[((Souradnice)zmacknuteTlacitko.Tag).Radek, ((Souradnice)zmacknuteTlacitko.Tag).Sloupec].Figurka.MozneTahy().Select(x => x.BudouciPolicko));

                                // Označí políčka graficky
                                foreach (Policko policko in oznacenePolicko)
                                {
                                    policko.Oznacit();
                                }
                                oznaceno = true;
                            }
                        }
                    }
                    // Kliknuto na označené tlačítko
                    else
                    {
                        bool presunuto = false;
                        foreach (Policko policko in oznacenePolicko)
                        {
                            // Zjistí, jestli bylo kliknuto na označené tlačítko
                            if (Hra.PolickaHraciDesky[((Souradnice)zmacknuteTlacitko.Tag).Radek, ((Souradnice)zmacknuteTlacitko.Tag).Sloupec] == policko)
                            {
                                // Ošetří, jestli nebylo kliknuto na aktuální pozici (na sebe sama)
                                if (policko != oznacenePolicko[0])
                                {
                                    Hra.PresunFigurky(new Tah(oznacenePolicko[0], policko));
                                    presunuto = true;
                                }
                            }
                            policko.Odznacit();
                        }
                        oznaceno = false;

                        if (!oznaceno && presunuto && HracCerveneFigurky == false && Hra.KonecHry == false)
                        {
                            cerveneAi = new AI(false);
                            if(cerveneAi != null)
                            {
                                Hra.ZalohujStav();
                                Tah tah = cerveneAi.Tah(hloubka);
                                Hra.PresunFigurky(tah);
                            }
                        }
                    }
                }
            }
        }
    }
}
