﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FriskaDama
{
    /// <summary>
    /// Interakční logika pro NovaHraWindow.xaml
    /// </summary>
    public partial class NovaHraWindow : Window
    {
        public bool HracModreFigurky { get; private set; }
        public bool HracCerveneFigurky { get; private set; }
        public bool Nastaveno { get; private set; }

        public NovaHraWindow(bool hracModreFigurky, bool hracCerveneFigurky)
        {
            this.HracCerveneFigurky = hracCerveneFigurky;
            this.HracModreFigurky = hracCerveneFigurky;

            InitializeComponent();

            if (HracCerveneFigurky)
            {
                this.cerveneComboBox.SelectedIndex = 0;
            }
            else
            {
                this.cerveneComboBox.SelectedIndex = 1;
            }

            if(HracModreFigurky)
            {
                this.modreComboBox.SelectedIndex = 0;
            }
        }

        private void modreComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if(modreComboBox.SelectedIndex == 0)
            {
                HracModreFigurky = true;
            }
        }

        private void cerveneComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (cerveneComboBox.SelectedIndex == 0)
            {
                HracCerveneFigurky = true;
            }
            else
            {
                HracCerveneFigurky = false;
            }
        }

        private void potvrditButton_Click(object sender, RoutedEventArgs e)
        {
            Nastaveno = true;
            Close();
        }

        private void zrusitButton_Click(object sender, RoutedEventArgs e)
        {
            Nastaveno = false;
        }
    }
}
