﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;

namespace FriskaDama
{
    public class Policko
    {
        public Souradnice Souradnice { get; private set; }
        public Figurka figurka;
        public Figurka Figurka
        {
            get
            {
                return figurka;
            }
            set
            {
                figurka = value;
                Vykresli();
            }
        }
        public Button Tlacitko { get; private set; }
        public Grid Grid { get; set; }

        public Policko(Button tlacitko, Souradnice souradnice)
        {
            Souradnice = souradnice;
            Tlacitko = tlacitko;
            Grid = new Grid();
            Grid.IsHitTestVisible = false;
            // Obarví tlačítko
            if (Souradnice.Sloupec % 2 != Souradnice.Radek % 2)
            {
                Tlacitko.Background = Brushes.Black;
            }
            else
            {
                Tlacitko.Background = Brushes.White;
            }
            // Označí tlačítko
            Tlacitko.Tag = Souradnice;
        }

        private void Vykresli()
        {
            if (Grid.Children.Count > 0)
                Grid.Children.RemoveAt(0);
            if (Figurka != null)
            {
                Grid.Children.Add(Figurka.Obrazek);
            }
            Tlacitko.Content = Grid;
        }

        public void Oznacit()
        {
            Grid.Children.Add(OznacenePolicko(Brushes.Green));
            Tlacitko.Content = Grid;
        }

        private Rectangle OznacenePolicko(Brush barva)
        {
            Rectangle oznacenePolicko = new Rectangle();
            oznacenePolicko.Fill = barva;
            oznacenePolicko.Opacity = 0.3;
            oznacenePolicko.Stretch = Stretch.UniformToFill;
            oznacenePolicko.HorizontalAlignment = HorizontalAlignment.Stretch;
            oznacenePolicko.IsHitTestVisible = false;
            return oznacenePolicko;
        }

        public void Odznacit()
        {
            Grid.Children.RemoveRange(0, Grid.Children.Count);
            if (Figurka != null)
                Grid.Children.Add(Figurka.Obrazek);
        }
    }
}
